
function ExecuteInstruction( Opcode : String ) : Boolean; far; external;
{ tries to execute instruction with opcode Opcode, returns True if it caused
  an "Invalid opcode" exception, False otherwise. }
{$L trap06}

function CvtStr( S : String ) : String;
var S1,R : String;
    i  : Byte;
    b  : Byte;
    C  : Integer;
begin
 CvtStr := '';
 R := '';
 if Length(S) mod 2 <> 0 then
  exit;
 i := 1;
 repeat
  S1 := '$'+Copy(S,i,2);
  Val(S1,b,C);
  if C <> 0 then
   exit;
  R := R + Char(b);
  Inc(i,2);
 until i >= Length(S);
 CvtStr := R;
end;

var Opcode, InStr : String;

const
	Trapped : array[Boolean] of String[2] = ('','in');

begin
 WriteLn('x86 Opcode Execution Test  Version 1.00  Copyright(c) 1995 by B-coolWare.');
 WriteLn;
 Write('Enter opcode to test (hex, up to 10 bytes): ');
 ReadLn(InStr);
 Opcode := CvtStr(InStr);
 if Opcode = '' then
  begin
   WriteLn;
   WriteLn('Input is invalid. You must enter it in hexadecimal and with all zeros');
   WriteLn('in appropriate places. For example, opcode 0F A2 (P5 cpuid instruction)');
   WriteLn('must be entered as "0FA2".');
   Halt;
  end;
 WriteLn('About to test entered opcode, the computer may hang...');
 WriteLn;
 WriteLn('The opcode is ',Trapped[ExecuteInstruction(Opcode)],'valid for current CPU.');
end.
