	MODEL	TPASCAL

	.CODE

	LOCALS
	JUMPS

	.386

	PUBLIC	ExecuteInstruction

ExecuteInstruction	proc far Opcode: DWORD
	mov	cs:Trapped,0	; reset Trapped flag

;	now saving crucial registers

	mov	cs:_esp,esp
	mov	cs:_ebp,ebp
	mov	cs:_ds,ds
	mov	cs:_es,es
	mov	cs:_ss,ss
	mov	cs:_fs,fs
	mov	cs:_gs,gs

	push	ds

	lds	si,Opcode	; copy the instruction into internal buffer
	lodsb
	mov	cl,al
	sub	ch,ch
	mov	ax,ds
	pop	ds
	jcxz	@@Q
	cmp	cx,10
	ja	@@Q
	push	ds
	mov	ds,ax
	push	cs
	pop	es
	mov	di,offset @@instr
	cld
	rep	movsb
	mov	ax,3506h	; get INT 06 vector
	int	21h
	mov	cs:_oldcs,es
	mov	cs:_oldip,bx
	mov	ax,2506h	; and set our handler for trap 06
	push	cs
	pop	ds
	mov	dx,offset @@trap06
	int	21h
	pop	ds
@@instr:
	db	10 dup(90h)
@@aftertrap:
	mov	esp,cs:_esp	; restore possibly damaged registers
	mov	ebp,cs:_ebp
	mov	ax,cs:_gs
	mov	gs,ax
	mov	ax,cs:_fs
	mov	fs,ax
	mov	ax,cs:_ss
	mov	ss,ax
	mov	ax,cs:_es
	mov	es,ax
	mov	ax,cs:_ds
	mov	ds,ax
	push	ds
	mov	ax,cs:_oldcs	; restore old handler
	mov	ds,ax
	mov	dx,cs:_oldip
	mov	ax,2506h
	int	21h
	pop	ds
@@Q:
	mov	al,cs:Trapped
	ret
@@trap06:
	mov	cs:Trapped,1
	add	sp,4
	popf
	jmp	@@aftertrap
	endp

_esp	dd	?
_ebp	dd	?
_ds	dw	?
_es	dw	?
_ss	dw	?
_fs	dw	?
_gs	dw	?
Trapped	db	0
_oldcs	dw	?
_oldip	dw	?

	END
